﻿namespace TabsStudioMarker
{
    class WindowDocument
    {
        public WindowDocument(EnvDTE.Window window_)
        {
            window = window_;
            document = GetWindowID(window);
            InitProject();
            InitSolutionItem();
        }

        public void UpdateDocument()
        {
            document = GetWindowID(window);
        }

        private static string GetWindowID(EnvDTE.Window window)
        {
            try
            {
                if (window.Document != null) // can throw
                    return window.Document.FullName;
            }
            catch (System.Exception)
            {
            }
            return window.Caption;
        }

        private void InitProject()
        {
            try
            {
                if (window.Document != null && window.Document.ProjectItem != null &&
                    window.Document.ProjectItem.ContainingProject != null)
                {
                    EnvDTE.Project project = window.Document.ProjectItem.ContainingProject;
                    projectID = project.UniqueName;
                    projectPath = System.IO.Path.GetDirectoryName(project.FullName);
                }
            }
            catch (System.Exception)
            {
            }
        }

        private void InitSolutionItem()
        {
            try
            {
                if (window.Document != null && window.Document.ProjectItem != null && window.Document.ProjectItem.Collection != null)
                {
                    EnvDTE.Project p = window.Document.ProjectItem.Collection.Parent as EnvDTE.Project;
                    if (p != null && p.Kind == EnvDTE.Constants.vsProjectKindSolutionItems)
                        solutionItem = true;
                }
            }
            catch (System.Exception)
            {
            }
        }

        public EnvDTE.Window window;
        public string document;
        public string projectID, projectPath;
        public bool solutionItem;
    }
}
